package imageViewer;

import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Dimension;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import java.io.File;

@SuppressWarnings("serial")
public class MainFrame extends JFrame{
	private MyPanel panel;
	
	public MainFrame() {
		//ʼ˵
		JMenuItem openOption = new JMenuItem("");
		JMenuItem exitOption = new JMenuItem("˳");
		
		openOption.addActionListener(new OpenListener(this));
		exitOption.addActionListener(new ExitListener());
		
		JMenu menu = new JMenu("ļ");
		menu.add(openOption);
		menu.add(exitOption);
		
		JMenuBar menuBar = new JMenuBar();
		menuBar.add(menu);
		
		//ʼͼ塣
		panel = new MyPanel();
		panel.setBackground(new Color(66, 204, 255));
		
		this.add(panel);
		this.setJMenuBar(menuBar);
		
		this.setResizable(false);
	}
	
	public MyPanel getPanel() {return this.panel;}
}

/** Զͼ塣*/
class MyPanel extends JPanel {
	private static final long serialVersionUID = 287940773057884149L;
	Image img;
	
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		g.drawImage(img, 0, 0, this);
	}
	
	public void setImage(Image img) {this.img = img;}
}

/**򿪡˵¼*/
class OpenListener implements ActionListener {
	MainFrame parent;
	
	OpenListener(MainFrame parent) {this.parent = parent;}
	
	public void actionPerformed(ActionEvent e) {
		Image img;
		if ((img = getImage()) != null) {
			parent.getPanel().setImage(img);
			parent.getPanel().setPreferredSize(new Dimension(img.getWidth(parent), img.getHeight(parent)));
			parent.pack();
		} else {
			return;
		}
	}
	
	/**ʾȡļȻ󷵻*/
	private File getFile() {
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fileChooser.setMultiSelectionEnabled(false);
		fileChooser.setCurrentDirectory(new File("."));
		fileChooser.setFileFilter(new MyFilter());
		fileChooser.setFileHidingEnabled(true);
		if (fileChooser.showOpenDialog(parent) == JFileChooser.APPROVE_OPTION)
			return fileChooser.getSelectedFile();
		else
			return null;
	}
	
	/**getFileȡļݲΪݵͼƬΪ˽׳ԱӦжһļ͵ģԼþˡ*/
	private Image getImage() {
		File file = getFile();
		if (file == null)
			return null;
		else
			return new ImageIcon(file.getPath()).getImage();
	}
	
	/**ļ͹òţдڲࡣ*/
	class MyFilter extends FileFilter {
		@Override
		public boolean accept(File f) {
			return (f.isDirectory() ||
					f.getName().endsWith(".jpg") ||
					f.getName().endsWith(".gif") ||
					f.getName().endsWith(".png"));
		}
		
		@Override
		public String getDescription() {
			return ".jpg|.gif|.png";
		}
	}
}

/**˳˵¼*/
class ExitListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
		System.exit(0);
	}
}